
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C++ 中左值和右值的探讨 / 憋错料</title>

    <meta name="description" content="C++ 中左值和右值的探讨 我的主力博客:半亩方塘 对于 C++ 中的左值和右值,我们通常的说法是:当一个对象被用作右值的时候,用的是对象的值(内容):当对象被用作左值的时候,用的是对象的身份(在内存中的位置),这句话来自于 &lt;C++ Primer 第五版&gt; 第 121 页,那么,对于这句话,该作何理解呢?下面我想来谈谈我的看法: ISO C++03规定表达式必须是左值或右值之一,而在ISO C++11中,左值性被正式地扩充为更复杂的值类别,对于一个变量来说,与它相关的有两个部分:一是变量在内存中的地址,二是这 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">C++ 中左值和右值的探讨</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>我的主力博客：<a href="http://abnerwang.github.io" rel="external nofollow noreferrer">半亩方塘</a></p>
<p>对于 C&#043;&#043; 中的左&#20540;和右&#20540;，我们通常的说法是：当一个对象被用作右&#20540;的时候，用的是对象的&#20540;（内容）；当对象被用作左&#20540;的时候，用的是对象的身份（在内存中的位置），这句话来自于&nbsp;<a href="http://book.douban.com/subject/25708312/" rel="external nofollow noreferrer">《C&#043;&#043;<br />
 Primer 第五版》</a>&nbsp;第 121 页，那么，对于这句话，该作何理解呢？下面我想来谈谈我的看法：</p>
<p>ISO C&#043;&#043;03规定表达式必须是左&#20540;或右&#20540;之一，而在ISO C&#043;&#043;11中，左&#20540;性被正式地扩充为更复杂的&#20540;类别，对于一个变量来说，与它相关的有两个部分：一是变量在内存中的地址，二是这个变量在内存中的地址中所存储的数据。当我们使用变量在内存中的地址的时候，譬如给变量赋&#20540;，实际上使用的是变量的身份，而不是变量的&#20540;（内容），此时，变量是被用作左&#20540;的；当我们使用变量的&#20540;（内容）的时候，譬如把变量的&#20540;赋给另一个对象的时候，变量是被用作右&#20540;的。由此可见，变量既可以被用作左&#20540;也可以被用作右&#20540;，那么变量究竟是左&#20540;还是右&#20540;呢？<a href="http://book.douban.com/subject/25708312/" rel="external nofollow noreferrer">《C&#043;&#043;<br />
 Primer 第五版》</a>&nbsp;第 121 页中又写到，&nbsp;一个重要的原则（有一种例外）是在需要右&#20540;的地方可以用左&#20540;代替，但是不能把右&#20540;当作左&#20540;&nbsp;，由此可见，一个变量表达式是左&#20540;。</p>
<p>以上说了那么多其实还没有说到判断一个表达式究竟是左&#20540;还是右&#20540;的方法，那么，该怎样判断一个表达式是左&#20540;还是右&#20540;呢？对于“当对象被用作左&#20540;的时候，用的是对象的身份（在内存中的位置）”这句话，我们是不是可以这样理解，当一个表达式&nbsp;在自身所在的表达式结束之后有持久的身份（在内存中的位置）&nbsp;可以使用的时候，它就是一个左&#20540;，即&nbsp;可以对这个表达式运行结束之后取得持久的地址的时候，说明这个表达式是一个左&#20540;，否则是一个右&#20540;，为什么我们要强调&nbsp;在自身所在的表达式结束之后有持久的身份（在内存中的位置）&nbsp;这句话呢？因为我们使用一个表达式作为左&#20540;的时候早已经超出了这个表达式范围本身来使用它，如果离开这个表达式自身的范围就得不到这个表达式的地址的话，用表达式作为左&#20540;就没有任何意义了，下面通过一个例子来细细剖析这段内容：</p>
<p>对于前置递增（递减）运算符和后置递增（递减）运算符的表达式，究竟哪一个是左&#20540;哪一个是右&#20540;呢？针对前置递增和后置递增的情况，我们来分析一下，前置递减和后置递减可以同理分析：</p>
<p><code>&#043;&#043;i</code>&nbsp;这个前置递增表达式，是把 i 的&#20540;加 1 然后返回 i 的&#20540;，这个表达式的返回&#20540;是 i，对 i 取地址可以得到持久的地址，因此，对于前置递增表达式，它是一个左&#20540;；</p>
<p><code>i&#043;&#043;</code>&nbsp;这个后置递增表达式，是把 i &#20540;的副本返回后再把 i 加 1，这个表达式返回的实际上是一个 i 的副本（临时量），而不是 i 本身（i 本身已加<br />
 1），所以，在这个表达式运行结束的时候，我们对这个表达式取地址，将得不到一个持久的地址，因为这个临时量随着表达式的结束已经不复存在了，因此，对于后置递增表达式，它是一个右&#20540;；</p>
<p>对于前置递增和后置递增运算符，它们操作对象究竟是一个左&#20540;还是右&#20540;呢？<code>&#043;&#043;i</code>&nbsp;这个前置递增表达式，最后返回的是 i 本身，它使用的是 i 的身份，因此此处的<br />
 i 是作为左&#20540;使用的，<code>i&#043;&#043;</code>&nbsp;这个后置递增表达式，最后返回的是 i 的副本，它使用的是 i 的内容，因此此处的 i 是作为右&#20540;使用的。</p>
<p>我们来看看对于表达式&nbsp;<code>&#043;&#043;i--</code>&nbsp;加上括号，变成&nbsp;<code>&#043;&#043;(i--)</code>&nbsp;之后，这个表达式是不是合法的呢？通过上面的分析我们知道，前置递增（递减）运算符的操作对象是一个左&#20540;，后置递增（递减）运算符的操作对象是一个右&#20540;，但是<code>i--</code>&nbsp;这个表达式是一个右&#20540;，而前置递增（递减）运算符的操作对象是一个左&#20540;，所以，<code>&#043;&#043;(i--)</code>&nbsp;这个表达式是不合法的。</p>
<p>通过以上的分析我相信对于 C&#043;&#043; 中的左&#20540;和右&#20540;能有一个深刻地理解了，其实说到底就一句话，这里最后再强调一下：&nbsp;可以对这个表达式运行结束之后取得持久的地址的时候，说明这个表达式是一个左&#20540;，否则是一个右&#20540;</p>
<p>PS: 以上内容系原创，转载请注明地址</p>
<p><P><A href="http://www.bubuko.com/infodetail-153721.html" rel="external nofollow noreferrer">C++ 中左值和右值的探讨,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 07:38:57 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/%e5%b7%a6%e5%80%bc%e5%92%8c%e5%8f%b3%e5%80%bc/" title="左值和右值">左值和右值</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>C++ 中左值和右值的探讨的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kpXQP3.html" rel="bookmark">C&plus;&plus;：浅谈c&plus;&plus;资源管理以及对&lbrack;STL&rsqb;智能指针auto&lowbar;ptr源码分析，左值与右值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++:浅谈c++资源管理以及对[STL]智能指针auto_ptr源码分析 by 小威威 1. 知识引入 在C++编程中,动态分配的内存在使用完毕之后一般都要delete(释放),否则就会造成内存泄漏,导致不必要的后果.虽然大多数初学者都会有这样的意识,但是有些却不以为意.我曾问我的同学关于动态内存的分配与释放,他的回答是:&quot;只要保证new和delete成对出现就行了.如果在构造函数中new(动态分配内存),那么在析构函数中delete(释放)就可以避免内存泄漏了!&quot; 事实果真如此么?			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/35V52E4.html" rel="bookmark">（C&plus;&plus;）关于i&plus;&plus;和i&plus;&plus;的左值、右值问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.什么是左值和右值? 左值就是出现在表达式左边的值(等号左边),可以被改变,他是存储数据值的那块内存的地址,也称为变量的地址: 右值是指存储在某内存地址中的数据,也称为变量的数据. 左值可以作为右值,但右值不可以是左值. 因此也只有左值才能被取地址. 2.举两个问题: int i = 0; (i++)+=i; //错误 (++i)+=i; //正确 int *ip = &amp;(i++); //错误 int *ip = &amp;(++i); //正确 3.为什么i++不能作左值? 我们来看i++和i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NJPD84.html" rel="bookmark">c&plus;&plus;中的左值与右值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				++(a++) a++相当于 int a; { int temp=a; a++; teturn temp; } 所以我们可以将++(a++)看成++temp;而temp 显然是一个右值,所以不能用啊~~ L-value中的L指的是Location,表示可寻址.The &quot;l&quot; in lvalue can be though of as locationR-value中的R指的是Read,表示可读.The &quot;r&quot; in rvalue can be thought of			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xRWAj4.html" rel="bookmark">C 语言中的左值和右值。以及对比数组名和指针取数组元素的区别。</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				左值:出现在赋值符左边的符号有时称为左值. 右值:出现在赋值符右边的符号有时称为右值. 编译器为每个变量分配一个地址(左值),这个地址在编译时可知,而且该变量在运行时一直保存于这个地址.相反,存储于变量中的值(它的右值)只有在运行时才可知.如果需要用到变量中存储的值,编译器就发出指令从指定地址读入变量值并将它存于寄存器. 可以看到,每个符号的地址在编译时可知. 对比一下几个式子: //常规变量 int a=1;//这里a作为左值出现,代表的是地址,即在a表示的这个内存地址存入数值1.即a代表的内			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZAZpJ0.html" rel="bookmark">C&plus;&plus;11之右值引用：从左值右值到右值引用</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C++98中规定了左值和右值的概念,但是一般程序员不需要理解的过于深入,因为对于C++98,左值和右值的划分一般用处不大,但是到了C++11,它的重要性开始显现出来. C++98标准明确规定: 左值是可以取得内存地址的变量. 非左值即为右值. 从这里可以看出,可以执行&amp;取地址的就是左值,其他的就是右值. 这里需要明确一点,能否被赋值不是区分C++左值和右值的区别. 我们给出四个表达式: string one(&quot;one&quot;); const string two(&quot;two&			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPDEYaM.html" rel="bookmark">4&period;1  中的左值和右值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:  引自---http://www.cnblogs.com/catch/p/3500678.html 左值 (lvalue)和右值 (rvalue) 是 c/c++ 中一个比较晦涩基础的概念,有的人可能甚至没有听过,但这个概念到了 c++11 后却变得十分重要,它们是理解 move, forward 等新语义的基础. 左值右值的定义 左值与右值这两概念是从 c 中传承而来的,在 c 中,左值指的是既能够出现在等号左边也能出现在等号右边的变量(或表达式),右值指的则是只能出现在等号右边的变量			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bRQWL0.html" rel="bookmark">c&plus;&plus;11の的左值、右值以及move，foward</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				左值和右值的定义 在C++中,可以放到赋值操作符=左边的是左值,可以放到赋值操作符右边的是右值.有些变量既可以当左值又可以当右值.进一步来讲,左值为Lvalue,其实L代表Location,表示在内存中可以寻址,可以给它赋值(常量const类型也可以寻址,但是不能赋值),Rvalue中的R代表Read,就是可以知道它的值.例如: int a=3; a在内存中有地址,而3没有,但是可以read到它的值. 3=4; 这个是错误的,因为3的内存中没有地址,不能当作左值. 下面这个语句不容易出错 a++			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4AW8LD0.html" rel="bookmark">c&sol;c&plus;&plus;左值和右值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				C/C++中的变量有左值和右值之分,他们的区别主要如下: (1)左值可以放在赋值号 = 的左右两边,右值只能放在赋值号 = 的右边 (2)在C语言中,有名字的变量即为左值:而函数的运行结果或表达式中间变量即为右值 (3)对于内嵌类型(基本类型,即built-in types),右值是不可以被更改的,也不可以被const,volatile所修饰: 对于自定义类型,右值却可以通过它的成员函数来进行修改. (4)左值也可以作为右值表达式,变量可以是左值,也可以为右值,但常量只能是右值. (5)右值只能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xB1O74.html" rel="bookmark">&lbrack;转&rsqb; 左值和右值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://www.cnblogs.com/dejavu/archive/2012/09/02/2667640.html#commentform &lt;C/C++&gt; 左值和右值, L-value和R-value 一直以为左值是可以出现在赋值表达式左边(the left side of an assignment expression)的值,Left-value;右值即Right-value. 今天看到一个说法,觉得有点味道: L-value中的L指的是Location,表示可寻址. The &q			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/k0eqG50.html" rel="bookmark" class="title">大型网站系统架构的演化&lpar;转&rpar;</a>
					<div>
						前言 一个成熟的大型网站(如淘宝.京东等)的系统架构并不是开始设计就具备完整的高性能.高可用.安全等特性,它总是随着用户量的增加,业务功能的扩展逐渐演变完善的,在这个过程中,开发模式.技术架构.设计思 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MBJdvM.html" rel="bookmark" class="title">第八章：不要在构造和析构函数中使用虚函数</a>
					<div>
						前言 本文将讲解一个新手C++程序员经常会犯的错误 - 在构造/析构函数中使用虚函数,并分析错误原因所在以及规避方法. 错误起因 首先,假设我们以一个实现交易的类为父类,然后一个实现买的类,一个实现卖 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xR57N4.html" rel="bookmark" class="title">Spring AOP实现方式三【附源码】</a>
					<div>
						注解AOP实现 源码结构: 1.首先我们新建一个接口,love 谈恋爱接口. package com.spring.aop; /** * 谈恋爱接口 * * @author Administrator ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OZ7EX0.html" rel="bookmark" class="title">opencv就这么简单&comma; 就这么任性</a>
					<div>
						#include &lt;opencv2/opencv.hpp&gt;#include &lt;opencv2/imgproc/imgproc.hpp&gt;#include &lt;opencv2/ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38ba8KM.html" rel="bookmark" class="title">elasticsearch 初学 笔记（1）</a>
					<div>
						使用 curl进行数据的的格式, 1.下载curl,配置路径 格式 C:\Users\Administrator&gt;curl -XPUT http://localhost:9200/dept/em ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVPNk4.html" rel="bookmark" class="title">IIS无法加载 DLL解决办法</a>
					<div>
						IIS提示 无法加载 DLL“OraOps12.dll”: 找不到指定的模块. (异常来自 HRESULT:0x8007007E). 说明: 执行当前 Web 请求期间,出现未经处理的异常.请检查堆栈 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kPJp0.html" rel="bookmark" class="title">仿函数--创建结构体或类的内部函数指针</a>
					<div>
						body { font-family: 微软雅黑,&quot;Microsoft YaHei&quot;, Georgia,Helvetica,Arial,sans-serif,宋体, PMingLi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ezLnb3.html" rel="bookmark" class="title">关于ZMAX</a>
					<div>
						ZMAX程序人是一个专注于Joomla二次开发技术的团队,本团队自2008年起开始做joomla开发,至今已经有7年历史. 我们为数十家网站公司提供joomla技术支持,开发自定义扩展,在此期间经历了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aGRWP4.html" rel="bookmark" class="title">dao层的泛型实现&lpar;2种方法&rpar;</a>
					<div>
						前言 1.CSS    cascading   stylesheet  级联样式表 ,外观显示(页面内容显示的方式).CSS文档以.css作为后缀 2.w3c推荐页面文件定义 数据和结构   html ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVQxbz4.html" rel="bookmark" class="title">利用CORS实现跨域请求（转载）</a>
					<div>
						跨域请求一直是网页编程中的一个难题,在过去,绝大多数人都倾向于使用JSONP来解决这一问题.不过现在,我们可以考虑一下W3C中一项新的特性--CORS(Cross-Origin Resource Sh ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RkZDj3.html" rel="bookmark" class="title">Wb应用程序开放原理</a>
					<div>
						简介:基于wb的浏览器/服务器(简称B/S),架构编程,已经成为目前企业级应用程序开发的主流.                                1.企业应用计算的演变:主机/呀终端的集中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pgPzP3.html" rel="bookmark" class="title">解决首次在eclipse中使用maven构建hadoop等项目时报Missing artifact sun&period;jdk&colon;tools&colon;jar&colon;1&period;5&period;0的问题</a>
					<div>
						问题原因: eclipse中的maven插件默认没有引用环境变量,所以找不到jdk的路径,也就找不到tool.jar. 解决办法: 步骤如下: 1.关闭eclips 2.在eclipse的解压目录中与 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02oO2D3.html" rel="bookmark" class="title">SQL---数据库导入错误 0xc0202049&colon; 数据流任务 1&colon; 无法在只读列&OpenCurlyDoubleQuote;ID&rdquo;中插入数据</a>
					<div>
						数据库导入导出时总失败,错误信息如下: 正在验证 (错误) 消息错误 0xc0202049: 数据流任务 1: 无法在只读列“ID”中插入数据. (SQL Server 导入和导出向导) 解决方法:  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bLQ8V4.html" rel="bookmark" class="title">【COGS2479】 HZOI2016&mdash;偏序</a>
					<div>
						http://cogs.pro/cogs/problem/problem.php?pid=2479 (题目链接) 题意 四维偏序. Solution CDQ套CDQ. 细节 第二次分治不能直接按照mi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JOwv9M.html" rel="bookmark" class="title">用Arduino剖析PWM脉宽调制</a>
					<div>
						PWM(Pulse Width Modulation)简介 PWM,也就是脉冲宽度调制,用于将一段信号编码为脉冲信号,也就是方波信号.多用于在数字电路中驱动负载随时间变化的电子元件,如LED,电机等. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLQPDv0.html" rel="bookmark" class="title">第五天学习：html标签的学习3</a>
					<div>
						关键字:html标签的学习3 晨跑计划: 学习任务: 第4章 认识标签(第三部分) 4-1 使用&lt;a&gt;标签,链接到另一个页面 4-2 在新建浏览器窗口中打开链接 4-3 使用mailto在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3w5g8RM.html" rel="bookmark" class="title">Aerospike系列：2：商业版和社区版的比较</a>
					<div>
						http://www.aerospike.com/products-services					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPO9ay4.html" rel="bookmark" class="title">CODEVS 3049 舞蹈家怀特先生</a>
					<div>
						根据题目描述,只有一开始会站在0这个格子上,以后不会向这个格子移动 假设f[i][j][k] 为 当前时间i,两只脚分别在j,k两个格子上的最小体力花费 第i个时间的状态为f[i][a[i]][k]或 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vyjQa0.html" rel="bookmark" class="title">PHP不支持高版本的openssl</a>
					<div>
						现有一台LNMP测试环境机器,Centos 6.9 先前升级过openssl版本由1.0.1e升级到1.1.0f, 因工作需求,升级php版本,升级到5.6.30,编译php中指定--with-ope ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Qdz1e3.html" rel="bookmark" class="title">java操作excel表格（2003）</a>
					<div>
						package test; import java.io.BufferedInputStream; import java.io.File; import java.io.FileInputStrea ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
